/* Jeff Connelly
 * C2 L2 sizeof data types
 * 22Aug2002
 */

#include <iostream.h>       // for cout, cin
#include <stdlib.h>         // for system()
#include <bool.h>           // for bool

int main()
{
	signed char  letter = 'f';               // character -128..127
	unsigned char uchar = 0x42;              // unsigned character 0..0xFF
	short int    change = 32717;             // short integer 
	signed int   number = 2;                 // integer 
	unsigned int nosign = 'jeff';            // unsigned integer 0..0xFFFF_FFFF
	float        answer = (float)2.82;       // single precision floating point
	long int     digits = 65537;             // long integer
	bool         bfalse = false;             // typedef int
	bool         bltrue = true;              // typedef int
	double       saving = 3.1415926L;        // double precision floating point
	long double  lngdbl = 1.222222222222L;   // long double precision float
	__int64      xxxxxx = 0x7F7F7F7F7F7F7F7F;// 0..0xFFFF_FFFF_FFFF_FFFF

	cout << "C VARIABLE TYPE\t\tBYTES\t\tEXAMPLE VALUE" << endl;
	cout << "signed char  \t\t" << sizeof(letter) << " bytes\t\t" << letter << endl;
	cout << "unsigned char\t\t" << sizeof( uchar) << " bytes\t\t" <<  uchar << endl;
	cout << "short int    \t\t" << sizeof(change) << " bytes\t\t" << change << endl;
	cout << "signed int   \t\t" << sizeof(number) << " bytes\t\t" << number << endl;
	cout << "unsigned int \t\t" << sizeof(nosign) << " bytes\t\t" << nosign << endl;
	cout << "float        \t\t" << sizeof(answer) << " bytes\t\t" << answer << endl;
	cout << "long int     \t\t" << sizeof(digits) << " bytes\t\t" << digits << endl;
	cout << "bool         \t\t" << sizeof(bfalse) << " bytes\t\t" << bfalse << " false " << endl;
	cout << "bool         \t\t" << sizeof(bltrue) << " bytes\t\t" << bltrue << " true "  << endl; 
	cout << "double       \t\t" << sizeof(saving) << " bytes\t\t" << saving << endl;
	cout << "long double  \t\t" << sizeof(lngdbl) << " bytes\t\t" << lngdbl << endl;
	cout << "__int64      \t\t" << sizeof(xxxxxx) << " bytes\t\t" << (int)xxxxxx << endl;
	cout << endl;
	
	cout << "Character is " <<     letter << "\t\t\t\tASCII value is " << (int)letter << endl;
	cout << "ASCII is "     << (int)uchar << "\t\t\t\tcharacter is "   <<       uchar << endl;

	cout << endl << endl;
	system("pause");
	return 0;
}

// 'initializing' : conversion from 'const int' to 'float', possible loss of data
//#pragma warning(disable:4244)
//#pragma warning(default:4244)
