/* Jeff Connelly
 * 11Oct 2002
 * Fibonacci / Factorial
 */

#include <iostream.h>
#include <apvector.h>
#include <fstream.h>
#include <apstring.h>
#include <iomanip.h>

typedef long double number;

number fib(number lastlast, number last);
number fact(number f, number n);

int main()
{
	number end;
	number i;
	number n;
	apstring s;
	number sum, f = 1;
	number last = 1, lastlast = 0;
	//ofstream fs("temp");

	while(1)
	{
		cout << "Fibonacci/Factorial Program = 2nd column is fib(n), 3rd is fact(n)" << endl;
 		do
		{
			cout << "Iterate up to: ";
			getline(cin, s);
			end = atoi(s.c_str());
		} while(end <= 0);

		i = end;

		// page it yourself
		// fstream fs("temp"); fs << ... ; fs.close(fs); system("more temp")..
		while(i--)
		{
			n = end - i;

			if (n > 0)
				f = fact(f, n);
			sum = fib(lastlast, last);
			
			// fib(n - 2) and fib(n - 1) for fibonacci sequence
			lastlast = last;
			last = sum;

			cout << n << setw(25) << sum << setw(25) << f << endl;
			if ((int)n % 23 == 0)
				getline(cin, s);
		}
		
		cout << "Press RETURN to run again, CONTROL-BREAK to break: ";
		getline(cin, s);
	}

	return 0;
}

// Given fib[n-2] and fib[n-1], return fib[n]
number fib(number lastlast, number last)
{
	return lastlast + last;
}

// Given fact[n-1] and n, return fact[n]
number fact(number f, number  n)
{
	return f * n;
}