/* Jeff Connelly
 * 05 Dec 2002
 * Address Book
 */

#include <iostream.h>
#include <apvector.h>
#include <apstring.h>
#include <stdlib.h>

struct ADDRESS
{
	apstring name;
	apstring address;
	apstring city;
	apstring state;
	int zip;
	apstring phone;
};

class XXX{};    // exquisite "except" exception class
istream& operator>>(istream& cin, ADDRESS& addr);           // iostream operators
ostream& operator<<(ostream& cout, const ADDRESS& addr);
istream& operator>>(istream& cin, apvector<ADDRESS>& book);
ostream& operator<<(ostream& cout, apvector<ADDRESS>& book);


int main()
{
	apvector<ADDRESS> book;

	cout << "Address Book Program" << endl;
	cout << "To get the value in brackets, just press enter." << endl;

	while(1)
	{
		int i = 0;
		book.resize(i + 1);

		while(1)
		{
			cout << "-- entry #" << i + 1 << "--" << endl;
			try
			{
				//cin >> book[i++];
				apstring temp;

				cout << "Name [enter to quit]:    ";
				getline(cin, book[i].name); 
				if (!book[i].name.length()) 
					throw XXX();   // XXX marker to end of list if no input

				cout << "Address [12345]:         ";
				getline(cin, book[i].address);
				if (!book[i].address.length()) 
					book[i].address = "12345 Noname Street";    // default street
				
				cout << "City [Yucaipa]:          ";
				getline(cin, book[i].city);
				if (!book[i].city.length())
					book[i].city = "Yucaipa";                   // default city

				cout << "State code [CA]:         ";
				getline(cin, book[i].state);
				
				if (!book[i].state.length())
					book[i].state = "CA";
				cout << "Zip code [92399]:        ";
				getline(cin, temp); 
				book[i].zip = atoi(temp.c_str());
				if (!book[i].zip)
					book[i].zip = 92399;

				cout << "Telephone [800-555-1212]: ";
				getline(cin, book[i].phone);
				if (!book[i].phone.length())
					book[i].phone = "800-555-1212";

			} catch (XXX xxx) {
				xxx;
				book.resize(i -= 1);
				break;
			}
			book.resize(i + 1);
		}

		if (book.length() == 0)    // no inputs, quit
			break;

		for(i = 0; i < book.length(); i++)
		{
			cout << i + 1 << ".\t";
			cout << book[i].name << endl
               << "\t" << book[i].address << endl
		       << "\t" << book[i].city << ", " << book[i].state << " " << book[i].zip << endl
		       << "\t" << book[i].phone << endl;
		}

	}

	return 0;
}



