/* Jeff Connelly 
 * Ch8 Hw Problem #5
 * Mr. Bagg's APCS 11th Grade 1st Period
 * 20Oct 2002
 */

// "Rock-Paper-Scissors", all-new trinary version!

// This program implements a TRINARY (base 3) DYADIC (2-input) logic
// gate, found only on TERNACs such as Setun (circa 1958, Russia)--not
// binary computers-- to quickly calculate the result of the game

// "I think I saw a two..." --Bender(Futurama)
// Yes, yes he did

#include <iostream.h>
#include <stdlib.h>

int main()
{
	int user; // user "move"
	int a;    // user upper digit
	int b;    // user lower digit
	int comp; // computer "move";
	int outcome; // 0=p1 win, 1=tie, 2=p2 win

	cout << "Rock=0, Paper=1, Scissors=2, Quit=Control-C: ";
	cin >> user;

	// 0=00, 1=01, 2=11 - i cannot reveal the details 
	// This is done for easier (linear efficiency, bion) operation
	switch(user)
	{
	case 0: cout << "ROCK"; a = b = 0; break;
	case 1: cout << "PAPER"; a = 0; b = 1; break;
	case 2: cout << "SCISSORS"; a = 1; b = 1; user = 3;
	}
	cout << "\tvs\t";

	//cout << "User ab=" << a << b << endl;
	comp = rand() & 3;  // Random from 0-3
	//cout << "Input comp: ";
	//cin >> comp;

	if (comp == 2)      // 0b10 is NOT ALLOWED, EVER #I$(* 
		comp = 3;		

	// RPS = 012, think of it this way:
	// RR=00 1 = tie
	// RP=01 2 = p2 win
	// RS=02 0 = p1 win
	// PR=10 0 = p1 win
	// PP=11 1 = tie
	// PS=12 2 = p2 win
	// SR=20 2 = p2 win
	// SP=21 0 = p1 win
	// SS=22 1 = tie
	// Or, more simply: 120,012,210
	// Composition(see http://jeff.tk/bingates/ for help):
        //                  rol,buf,inv
	// rol is: a^b, ~(a & b)
	// buf is: a, b
	// inv is: ~(a | b), ~(a & b)
	// ALL CLEAR?! Good, moving right along...	
	switch(comp)
	{
	case 0: cout << "ROCK";
		outcome = ((a ^ b) << 1) | (!(a & b)); 
		break;
	case 1: cout << "PAPER";
		outcome = ((a & b) << 1) | (a | b);
		break;
	case 2:
	case 3: cout << "SCISSORS";
		outcome = (!(a | b) << 1) | !(a ^ b);
		break;
	default: cout << "Uh??" << comp << endl; exit(42);
	}
	cout << endl;

	switch(outcome)
	{
	case 0: cout << "Computer won!" << endl; break;
	case 1: cout << "tie" << endl; break;
	case 3: cout << "Human won" << endl; break;
	default: cout << "/Someones/ trinary logic is borked.. *looks around*" 
                      << outcome << endl;
	}
	return 0;
} 
