/* Jeff Connelly
 * Ch12 Lab1
 * Palidromes
 */

#include <apstring.h>
#include <iostream.h>
#include <bool.h>

bool is_palindrome(const apstring &text);

int main()
{
	apstring test;

	for(;;)
	{
		cout << "Enter a palidrome (^C to not run again): ";
		getline(cin, test);

		cout << (is_palindrome(test) ? "Is" : "Not") << " a palindrome" << endl << endl;
	}

	return 0;
}

// True if palidromic, ignoring non-alphanumeric, case-insensitive
// Maximum memory usage: text.length() * 2 + sizeof(int) * 2
bool is_palindrome(const apstring &word)
{
	int len = word.length();
	apstring plain;

	// Filter non-alphanumeric
	for (int j = 0; j < len; j++)
	{
		if (isalnum(word[j]))
			plain += tolower(word[j]);
	}
	len = plain.length() - 1;

	// Verify each character matches on the other end
	for (int i = 0; i < len; i++)
	{
		if (plain[i] != plain[len - i])
			return false;
	}
	return true;
}
