/* Jeff Connelly
 * 05 Dec 2002
 * Structure point
 */

#include <iostream.h>
#include <stdlib.h>

// Cartesian point on a plane
struct POINT
{
	double x, y;
};

// Line segment defined by two finite points
struct LINE
{
	POINT p1, p2;
};

istream& operator>>(istream&, POINT&);
istream& operator>>(istream&, LINE&);
double slope(LINE);
double xintercept(double m, double x, double y);

int main()
{
	LINE L;
	double m;


	cout << "Line Slope Program. To *not* run again, hit Control-C" << endl;

	for(;;)
	{
		// try (7,5) - (9,2)
		cin >> L;

		cout << endl << "The slope of the line is: " << (m = slope(L)) << endl;
		cout << endl << "X-Intercept: " << xintercept(m, L.p1.x, L.p1.y) << endl;
	}
	
	return 0;
}

// (x1,y1)
// (x2,y2)
// y = mx + b
// y = ((x1-x2)/(y1-y2))x + b
// y = -1/2x + b
// y1 = -1/2(x1) + b
//      5 = -1/2(7) + b
//--1/2(7)= -1/2(7)
// b = y1 - mx
double xintercept(double m, double x, double y)
{
	return y - m * x;
}

double slope(LINE line)
{
	return (line.p2.y - line.p1.y) / (line.p2.x - line.p1.x);
}

// cin >> point
istream& operator>>(istream& is, POINT& pt)
{
	cout << "Enter the x coordinate: ";
	cin >> pt.x;
	cout << "Enter the y coordinate: ";
	cin >> pt.y;
	return is;
}	

// cin >> line
istream& operator>>(istream& is, LINE& L)
{
	cout << "-- first point --" << endl;
	cin >> L.p1;
	cout << "-- second point --" << endl;
	cin >> L.p2;
	return is;
}

