// Circle class, implementation
// 2003-01-13 Jeff Connelly

#include "circle.h"

// default constructor, sets radius
Circle::Circle(double radius)           // by default set to 0.0
{
	Circle::radius = radius;            // this works
}

// copy constructor
Circle::Circle(const Circle &rhs)
{
	radius = rhs.radius;
}

// (Method to) set and return radius (of the circle)
double Circle::SetRadius(double radius)
{
	Circle::radius = radius;           // works like a charm

	return radius;
}

// (Method to find the) area (of the circle)
double Circle::Area()
{
	return PI * radius * radius;
}

// (Method to find the) circumference (of a circle)
double Circle::Circumference()
{
	return 2 * PI * radius;
}

// (Method to find the) diameter (of a circle)
double Circle::Diameter()
{
	return 2 * radius;
}



