/* Jeff Connelly
 * 05 Dec 2002
 * Address Book
 */

#include <iostream.h>
#include <apvector.h>
#include <apstring.h>
#include <stdlib.h>

struct ADDRESS
{
	apstring name;
	apstring address;
	apstring city;
	apstring state;
	int zip;
	apstring phone;
};


int main()
{
	apvector<ADDRESS> book;

	cout << "Address Book Program" << endl;

	while(1)
	{
		int i = 0;
		book.resize(0);

		while(1)
		{
			cout << "address #" << i + 1 <<  endl;
			apstring temp;

			book.resize(i + 1);
			cout << "Name (enter to quit): ";
			getline(cin, book[i].name); 
			if (!book[i].name.length()) 
			{
				book.resize(i);
				break;
			}

			cout << "Address: ";
			getline(cin, book[i].address);
			
			cout << "City: ";
			getline(cin, book[i].city);
			cout << "State: ";
			getline(cin, book[i].state);
			
			cout << "Zip: ";
			cin >> book[i].zip;
			cin.ignore(80, '\n');

			cout << "Telephone: ";
			getline(cin, book[i].phone);
			i++;
		}
		cout << "Done receiving entries." << endl;
		if (book.length() == 0)    // anything to show? 
			break;

 		// output address book
		for(i = 0; i < book.length(); i++)
		{
			cout << i + 1 << ".\t";
			cout << book[i].name << endl
                     << "\t" << book[i].address << endl
		       << "\t" << book[i].city << ", " << book[i].state << " " << book[i].zip << endl
		       << "\t" << book[i].phone << endl;
		}

	}

	return 0;
}



